
// This is a raw avi peeker - no API calls here thank you very much :)
//
// written by C.Moss using Delphi 6  ....  29th March 2003  ....  http://www.nospagetti.com
// tab setting 3'
//
// I wrote this as quickly as I could (short of time) so it's not as nice as it could be and may well have bugs
//
// Freeware, do as you see fit with this code

unit Unit1;

interface

uses
	Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
	Dialogs, StdCtrls;

			// avih flags
const	AVIF_HASINDEX								= $00000010;
			AVIF_MUSTUSEINDEX							= $00000020;
			AVIF_ISINTERLEAVED						= $00000100;
			AVIF_TRUSTCKTYPE							= $00000800;
			AVIF_WASCAPTUREFILE						= $00010000;
			AVIF_COPYRIGHTED							= $00020000;

			// strh flags
			AVISF_DISABLED								= $00000001;
			AVISF_VIDEO_PALCHANGES					= $00010000;

			// idx1 flags
			AVIIF_LIST									= $00000001;
			AVIIF_KEYFRAME								= $00000010;
			AVIIF_FIRSTPART							= $00000020;
			AVIIF_LASTPART								= $00000040;
			AVIIF_MIDPART								= $00000060;
			AVIIF_NOTIME								= $00000100;
			AVIIF_COMPUSE								= $0fff0000;

			// audi format tag
			WAVE_FORMAT_UNKNOWN						=	$0000;	// Microsoft Corporation
			WAVE_FORMAT_PCM							=	$0001;	// Microsoft Corporation
			WAVE_FORMAT_ADPCM							=	$0002;	// Microsoft Corporation
			WAVE_FORMAT_IBM_CVSD						=	$0005;	// IBM Corporation
			WAVE_FORMAT_ALAW							=	$0006;	// Microsoft Corporation
			WAVE_FORMAT_MULAW							=	$0007;	// Microsoft Corporation
			WAVE_FORMAT_OKI_ADPCM					=	$0010;	// OKI
			WAVE_FORMAT_DVI_ADPCM					=	$0011;	// Intel Corporation
			WAVE_FORMAT_IMA_ADPCM					=	$0011;	// Intel Corporation
			WAVE_FORMAT_MEDIASPACE_ADPCM			=	$0012;	// Videologic
			WAVE_FORMAT_SIERRA_ADPCM				=	$0013;	// Sierra Semiconductor Corp
			WAVE_FORMAT_G723_ADPCM					=	$0014;	// Antex Electronics Corporation
			WAVE_FORMAT_DIGISTD						=	$0015;	// DSP Solutions, Inc.
			WAVE_FORMAT_DIGIFIX						=	$0016;	// DSP Solutions, Inc.
			WAVE_FORMAT_DIALOGIC_OKI_ADPCM		=	$0017;	// Dialogic Corporation
			WAVE_FORMAT_YAMAHA_ADPCM				=	$0020;	// Yamaha Corporation of America
			WAVE_FORMAT_SONARC						=	$0021;	// Speech Compression
			WAVE_FORMAT_DSPGROUP_TRUESPEECH		=	$0022;	// DSP Group, Inc
			WAVE_FORMAT_ECHOSC1						=	$0023;	// Echo Speech Corporation
			WAVE_FORMAT_AUDIOFILE_AF36				=	$0024;	//
			WAVE_FORMAT_APTX							=	$0025;	// Audio Processing Technology
			WAVE_FORMAT_AUDIOFILE_AF10				=	$0026;	//
			WAVE_FORMAT_DOLBY_AC2					=	$0030;	// Dolby Laboratories
			WAVE_FORMAT_GSM610						=	$0031;	// Microsoft Corporation
			WAVE_FORMAT_MSN							=	$0032;	// Microsoft Corporation
			WAVE_FORMAT_ANTEX_ADPCME				=	$0033;	// Antex Electronics Corporation
			WAVE_FORMAT_CONTROL_RES_VQLPC			=	$0034;	// Control Resources Limited
			WAVE_FORMAT_DIGIREAL						=	$0035;	// DSP Solutions, Inc.
			WAVE_FORMAT_DIGIADPCM					=	$0036;	// DSP Solutions, Inc.
			WAVE_FORMAT_CONTROL_RES_CR10			=	$0037;	// Control Resources Limited
			WAVE_FORMAT_NMS_VBXADPCM				=	$0038;	// Natural MicroSystems
			WAVE_FORMAT_CS_IMAADPCM					=	$0039;	// Crystal Semiconductor IMA ADPCM
			WAVE_FORMAT_G721_ADPCM					=	$0040;	// Antex Electronics Corporation
			WAVE_FORMAT_MPEG							=	$0050;	// Microsoft Corporation
			WAVE_FORMAT_MPEG3							=	$0055;	// Microsoft Corporation
			WAVE_FORMAT_CELP48						=	$0070;	// Lernout & Hauspie
			WAVE_FORMAT_SBC8							=	$0071;	// Lernout & Hauspie
			WAVE_FORMAT_SBC12							=	$0072;	// Lernout & Hauspie
			WAVE_FORMAT_SBC16							=	$0073;	// Lernout & Hauspie
			WAVE_FORMAT_VOXRT							=	$0074;	// Voxware Audio
			WAVE_FORMAT_VOXAC							=	$0075;	// Voxware Audio
			WAVE_FORMAT_CREATIVE_ADPCM				=	$0200;	// Creative Labs, Inc
			WAVE_FORMAT_CREATIVE_FASTSPEECH8		=	$0202;	// Creative Labs, Inc
			WAVE_FORMAT_CREATIVE_FASTSPEECH10	=	$0203;	// Creative Labs, Inc
			WAVE_FORMAT_FM_TOWNS_SND				=	$0300;	// Fujitsu Corp.
			WAVE_FORMAT_OLIGSM						=	$1000;	// Ing C. Olivetti & C., S.p.A.
			WAVE_FORMAT_OLIADPCM						=	$1001;	// Ing C. Olivetti & C., S.p.A.
			WAVE_FORMAT_OLICELP						=	$1002;	// Ing C. Olivetti & C., S.p.A.
			WAVE_FORMAT_OLISBC						=	$1003;	// Ing C. Olivetti & C., S.p.A.
			WAVE_FORMAT_OLIOPR						=	$1004;	// Ing C. Olivetti & C., S.p.A.

type		FOURCC					=	packed array[0..3] of char;

			TAVIH						=	packed record
//												fcc						: FOURCC;	// ID
//												cb							: dword;	// size of following data
												dwMicroSecPerFrame	: dword;
												dwMaxBytesPerSec		: dword;
												dwPaddingGranularity	: dword;
												dwFlags					: dword;
												dwTotalFrames			: dword;
												dwInitialFrames		: dword;
												dwStreams				: dword;	// 1 for just video, 2 for video and audio
												dwSuggestedBufferSize: dword;
												dwWidth					: dword;
												dwHeight					: dword;
												dwReserved				: array[0..3] of dword;
											end;

			TSTRH						=	packed record
//												fcc						: FOURCC;	// ID
//												cb							: dword;	// size of following data
												fccType						: FOURCC;
												fccHandler					: FOURCC;
												dwFlags						: dword;
												wPriority					: word;
												wLanguage					: word;
												dwInitialFrames			: dword;
												dwScale						: dword;
												dwRate						: dword;
												dwStart						: dword;
												dwLength						: dword;
												dwSuggestedBufferSize	: dword;
												dwQuality					: dword;
												dwSampleSize				: dword;
												rcFrame						:	record
																						Left	: integer;	// short int
																						Top	: integer;
																						Right	: integer;
																						Bottom: integer;
																					end;
											end;

			TPAL						=	packed record
												bFirstEntry				: byte;
												bNumEntries				: byte;
												wFlags					: short;
											end;

			TIDX1						=	packed record
												ckid						: FOURCC;
												dwFlags					: dword;
												dwChunkOffset			: dword;
												dwChunkLength			: dword;
											end;

			TIDX2						=	packed record
//												fcc						: FOURCC;
//												cb							: dword;
												wLongsPerEntry			: word;						// size of each entry in aIndex array
												bIndexSubType			: byte;						// future use. must be 0
												bIndexType				: byte;						// one of AVI_INDEX_* codes
												nEntriesInUse			: dword;						// index of first unused member in aIndex array
												dwChunkId				: FOURCC;					// fcc of what is indexed
												dwReserved				: array[0..2] of dword;	// meaning differs for each index
											end;

			TWaveFormatEx			=	packed record
												wFormatTag				: word;
												nChannels				: word;
												nSamplesPerSec			: dword;
												nAvgBytesPerSec		: dword;
												nBlockAlign				: word;
												wBitsPerSample			: word;
												cbSize					: word;
											end;

	TForm1 = class(TForm)
	  Memo1: TMemo;
	  OpenDialog1: TOpenDialog;
	  Edit1: TEdit;
	  Button1: TButton;
	  ShowJunkCheckBox: TCheckBox;
	  ShowIndexTableCheckBox: TCheckBox;
	  StopButton: TButton;
	  procedure Button1Click(Sender: TObject);
	  procedure FormCreate(Sender: TObject);
	  procedure StopButtonClick(Sender: TObject);
    procedure FormKeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
	private
		procedure WMWindowPosChanging(var MSG: Tmessage); message WM_WindowPosChanging;
		procedure ShowData(Size: integer);
		function STRHChunk(Size: integer): boolean;
		function STRFChunkVideo(Size: integer): boolean;
		function STRFChunkAudio(Size: integer): boolean;
		function AVIHChunk(Size: integer): boolean;
		function IDX1Chunk(Size: integer): boolean;
		function IDX2Chunk(Size: integer): boolean;
		function GetChunkString(Size: integer): boolean;

		function GetChunkID: boolean;
		function GetChunkSize: boolean;
		function SeekTo(i: integer): boolean;

		procedure ShowAVIInfo(Sender: TObject; Filename: string);
	public
	end;

var
	Form1: TForm1;

implementation

{$R *.dfm}

var	AviFile			: file;
		Paragraph		: string = '';
		EndOfListPos	: integer;
		LastChunkID		: FOURCC;
		ChunkID			: FOURCC;
		ChunkSize		: dword;
		ChunkPos			: dword;
		STRH				: TSTRH;
		STRFVideo		: TBitmapInfoHeader;
		STRFAudio		: TWaveFormatEx;
		FileP				: integer;
		Stop				: boolean = false;

//*************************

procedure TForm1.WMWindowPosChanging(var MSG: Tmessage);
// Limit the forms position
var WorkArea: TRect;
Begin
	inherited;	// call parent proc first

	if (not SystemParametersInfo(SPI_GETWORKAREA, 0, @WorkArea, 0)) then exit;

	with PWindowPos(MSG.lparam)^ do
	begin
		if (x < (WorkArea.Left - round(Width * 0.9))) then x := WorkArea.Left - round(Width * 0.9)
		else
		if (x > (WorkArea.Right - round(Width * 0.1))) then x := WorkArea.Right - round(Width * 0.1);

		if (y < WorkArea.Top) then y := WorkArea.Top
		else
		if (y > (WorkArea.Bottom - round(Height * 0.1))) then y := WorkArea.Bottom - round(Height * 0.1);

		// stick to the screen edges
		if (Abs(x - WorkArea.Left) < 10) then x := WorkArea.Left;
		if (Abs((x + width) - WorkArea.Right) < 10) then x := WorkArea.Right - Width;
		if (Abs(y - WorkArea.Top) < 10) then y := WorkArea.Top;
		if (Abs((y + height) - WorkArea.Bottom) < 10) then y := WorkArea.Bottom - Height;
	end;
end;

//****************************************************************************

procedure GetBuildInfo(var v1, v2, v3, v4: word);
var	VerInfoSize	: DWord;
		VerInfo		: Pointer;
		VerValueSize: DWord;
		VerValue		: PVSFixedFileInfo;
		dw				: dword;
begin
	VerInfoSize := GetFileVersionInfoSize(PChar(Application.ExeName), dw);
	GetMem(VerInfo, VerInfoSize);
	GetFileVersionInfo(PChar( Application.ExeName), 0, VerInfoSize, VerInfo);
	VerQueryValue(VerInfo, '\', Pointer(VerValue), VerValueSize);
	with VerValue^ do
	begin
		v1 := (dwFileVersionMS shr 16) and $FFFF;
		v2 := dwFileVersionMS and $FFFF;
		v3 := (dwFileVersionLS shr 16) and $FFFF;
		v4 := dwFileVersionLS and $FFFF;
	end;
	FreeMem(VerInfo, VerInfoSize);
end;

function fourcc_to_str(fcc: fourcc): string;
begin
	result := fcc[0] + fcc[1] + fcc[2] + fcc[3];
end;

function WaveFormatTagStr(Tag: word): string;
begin
	case Tag of
		$0000	:	Result := 'WAVE_FORMAT_UNKNOWN'; 	// Microsoft Corporation
		$0001	:	Result := 'PCM'; 							// Microsoft Corporation
		$0002	:	Result := 'MS ADPCM';					// Microsoft Corporation
		$0005	:	Result := 'IBM CVSD';					// IBM Corporation
		$0006	:	Result := 'MS ALAW';						// Microsoft Corporation
		$0007	:	Result := 'MS MULAW';					// Microsoft Corporation
		$0010	:	Result := 'OKI ADPCM';					// OKI
		$0011	:	Result := 'Intel DVI/IMA ADPCM';		// Intel Corporation
		$0012	:	Result := 'MediaSpace ADPCM';			// Videologic
		$0013	:	Result := 'Sierra ADPCM';				// Sierra Semiconductor Corp
		$0014	:	Result := 'Antex G723 ADPCM';			// Antex Electronics Corporation
		$0015	:	Result := 'DigiSTD';						// DSP Solutions, Inc.
		$0016	:	Result := 'DigiFIX';						// DSP Solutions, Inc.
		$0017	:	Result := 'Dialogic OKI ADPCM';		// Dialogic Corporation
		$0020	:	Result := 'Yamaha ADPCM';				// Yamaha Corporation of America
		$0021	:	Result := 'Sonarc';						// Speech Compression
		$0022	:	Result := 'DSP Group TRUESPEECH';	// DSP Group, Inc
		$0023	:	Result := 'Echo SC1';					// Echo Speech Corporation
		$0024	:	Result := 'AudioFile AF36';			//
		$0025	:	Result := 'Aptx';			 				// Audio Processing Technology
		$0026	:	Result := 'AufioFile AF10';			//
		$0030	:	Result := 'Dolby AC2';					//	Dolby Laboratories
		$0031	:	Result := 'GSM610';					  	// Microsoft Corporation
		$0032	:	Result := 'MSN';						  	// Microsoft Audio Network
		$0033	:	Result := 'Antex ADPCME';				// Antex Electronics Corporation
		$0034	:	Result := 'Control Res'' VQLPC';		// Control Resources Limited
		$0035	:	Result := 'DigiREAL';					// DSP Solutions, Inc.
		$0036	:	Result := 'DigiADPCM';					// DSP Solutions, Inc.
		$0037	:	Result := 'Control Res'' CR10';		// Control Resources Limited
		$0038	:	Result := 'NMS VBXADPCM';				// Natural MicroSystems
		$0039	:	Result := 'CS IMAADPCM';				// Crystal Semiconductor IMA ADPCM
		$0040	:	Result := 'Antex G721 ADPCM';			// Antex Electronics Corporation
		$0050	:	Result := 'MPEG';							// Microsoft Corporation
		$0055	:	Result := 'MPEG3';
		$0070	:	Result := 'L&H CELP 4.8kbit/s';		// Lernout & Hauspie
		$0071	:	Result := 'L&H SBC 8kbit/s';	 		// Lernout & Hauspie
		$0072	:	Result := 'L&H SBC 12kbit/s';	 		// Lernout & Hauspie
		$0073	:	Result := 'L&H SBC 16kbit/s';	 		// Lernout & Hauspie
		$0074	:	Result := 'Voxware RT';	 				// Voxware Audio
		$0075	:	Result := 'Voxware AC';					// Voxware Audio
		$0200	:	Result := 'Creative ADPCM';			// Creative Labs, Inc
		$0202	:	Result := 'Creative FASTSPEECH 8';	// Creative Labs, Inc
		$0203	:	Result := 'Creative FASTSPEECH 10';	// Creative Labs, Inc
		$0300	:	Result := 'FM Towns SND';				// Fujitsu Corp.
		$1000	:	Result := 'Olivetti GSM';				// Ing C. Olivetti & C., S.p.A.
		$1001	:	Result := 'Olivetti ADPCM';			// Ing C. Olivetti & C., S.p.A.
		$1002	:	Result := 'Olivetti CELP';				// Ing C. Olivetti & C., S.p.A.
		$1003	:	Result := 'Olivetti SBC';				// Ing C. Olivetti & C., S.p.A.
		$1004	:	Result := 'Olivetti OPR';				// Ing C. Olivetti & C., S.p.A.
	else
		Result := 'Unknown format ' + IntToHex(Tag, 4);
	end;
end;

//****************************************************************************

procedure TForm1.ShowData(Size: integer);
var	BytesRead: integer;
		ior, i, j: integer;
		Buffer	: pchar;
		s1, s2	: string;
begin
	if (Size <= 0) then exit;

	Buffer := nil;
	GetMem(Buffer, Size);
	if (Buffer = nil) then exit;
	
	BlockRead(AviFile, Buffer^, Size, BytesRead); ior := ioresult;
	if (ior <> 0) or (BytesRead <> Size) then
	begin
		Memo1.Lines.Add('            ' + Paragraph + 'Read error');
		exit;
	end;

	FileP := FilePos(AviFile); ior := ioresult;
	if (ior <> 0) then
	begin
		CloseFile(AviFile); ior := ioresult;
		Memo1.Lines.Add('          ' + Paragraph + 'FilePos error');
		exit;
	end;

	i := 0;
	while (i < Size) do
	begin
		s1 := '';
		s2 := '';
		j := 0;
		while (i < Size) and (j < 16) do
		begin
			s1 := s1 + ' ' + IntToHex(ord(Buffer[i]), 2);
			if (ord(Buffer[i]) < 32) then
				s2 := s2 + '.'
			else
				s2 := s2 + Buffer[i];
			inc(i);
			inc(j);
		end;
		j := 16 * 3;
		while (length(s1) < j) do s1 := s1 + ' ';
		Memo1.Lines.Add('            ' + Paragraph + s1 + '   ' + s2);
	end;

	FreeMem(Buffer);
end;

function TForm1.STRHChunk(Size: integer): boolean;
var	BytesRead: integer;
		ior, i	: integer;
		s			: string;
begin
	result := false;

	BlockRead(AviFile, STRH, sizeof(STRH), BytesRead); ior := ioresult;
	if (ior <> 0) or (BytesRead <> sizeof(STRH)) then
	begin
		Memo1.Lines.Add('            ' + Paragraph + 'Read error');
		exit;
	end;

	FileP := FilePos(AviFile); ior := ioresult;
	if (ior <> 0) then
	begin
		CloseFile(AviFile); ior := ioresult;
		Memo1.Lines.Add('          ' + Paragraph + 'FilePos error');
		exit;
	end;

	Memo1.Lines.Add('            ' + Paragraph + format('fccType: %s', [fourcc_to_str(STRH.fccType)]));
	Memo1.Lines.Add('            ' + Paragraph + format('fccHandler: %s', [fourcc_to_str(STRH.fccHandler)]));

	s := '';
	if ((STRH.dwFlags and AVISF_DISABLED) <> 0) then s := s + ', AVISF_DISABLED';
	if ((STRH.dwFlags and AVISF_VIDEO_PALCHANGES) <> 0) then s := s + ', AVISF_VIDEO_PALCHANGES';
	Memo1.Lines.Add('            ' + Paragraph + format('dwFlags: %d%s', [STRH.dwFlags, s]));

	Memo1.Lines.Add('            ' + Paragraph + format('wPriority: %d', [STRH.wPriority]));
	Memo1.Lines.Add('            ' + Paragraph + format('wLanguage: %d', [STRH.wLanguage]));
	Memo1.Lines.Add('            ' + Paragraph + format('dwInitialFrames: %d', [STRH.dwInitialFrames]));
	Memo1.Lines.Add('            ' + Paragraph + format('dwScale: %d', [STRH.dwScale]));
	Memo1.Lines.Add('            ' + Paragraph + format('dwRate: %d', [STRH.dwRate]));
	Memo1.Lines.Add('            ' + Paragraph + format('dwStart: %d', [STRH.dwStart]));
	Memo1.Lines.Add('            ' + Paragraph + format('dwLength: %d', [STRH.dwLength]));
	Memo1.Lines.Add('            ' + Paragraph + format('dwSuggestedBufferSize: %d', [STRH.dwSuggestedBufferSize]));
	Memo1.Lines.Add('            ' + Paragraph + format('dwQuality: %d', [STRH.dwQuality]));
	Memo1.Lines.Add('            ' + Paragraph + format('dwSampleSize: %d', [STRH.dwSampleSize]));
	Memo1.Lines.Add('            ' + Paragraph + format('rcFrame.Left: %d', [STRH.rcFrame.Left]));
	Memo1.Lines.Add('            ' + Paragraph + format('rcFrame.Top: %d', [STRH.rcFrame.Top]));
	Memo1.Lines.Add('            ' + Paragraph + format('rcFrame.Right: %d', [STRH.rcFrame.Right]));
	Memo1.Lines.Add('            ' + Paragraph + format('rcFrame.Bottom: %d', [STRH.rcFrame.Bottom]));

	i := Size - sizeof(STRH);
	if (i > 0) then ShowData(i);

	result := true;
end;

function TForm1.STRFChunkVideo(Size: integer): boolean;
var	BytesRead: integer;
		ior, i	: integer;
		s			: string;
begin
	result := false;

	BlockRead(AviFile, STRFVideo, sizeof(STRFVideo), BytesRead); ior := ioresult;
	if (ior <> 0) or (BytesRead <> sizeof(STRFVideo)) then
	begin
		Memo1.Lines.Add('            ' + Paragraph + 'Read error');
		exit;
	end;

	FileP := FilePos(AviFile); ior := ioresult;
	if (ior <> 0) then
	begin
		CloseFile(AviFile); ior := ioresult;
		Memo1.Lines.Add('          ' + Paragraph + 'FilePos error');
		exit;
	end;

	Memo1.Lines.Add('            ' + Paragraph + format('biSize: %d', [STRFVideo.biSize]));
	Memo1.Lines.Add('            ' + Paragraph + format('biWidth: %d', [STRFVideo.biWidth]));
	Memo1.Lines.Add('            ' + Paragraph + format('biHeight: %d', [STRFVideo.biHeight]));
	Memo1.Lines.Add('            ' + Paragraph + format('biPlanes: %d', [STRFVideo.biPlanes]));
	Memo1.Lines.Add('            ' + Paragraph + format('biBitCount: %d', [STRFVideo.biBitCount]));

	s := trim(fourcc_to_str(fourcc(STRFVideo.biCompression)));
	if (s = '') then s := 'none';
	Memo1.Lines.Add('            ' + Paragraph + format('biCompression: %s', [s]));

	Memo1.Lines.Add('            ' + Paragraph + format('biSizeImage: %d', [STRFVideo.biSizeImage]));
	Memo1.Lines.Add('            ' + Paragraph + format('biXPelsPerMeter: %d', [STRFVideo.biXPelsPerMeter]));
	Memo1.Lines.Add('            ' + Paragraph + format('biYPelsPerMeter: %d', [STRFVideo.biYPelsPerMeter]));
	Memo1.Lines.Add('            ' + Paragraph + format('biClrUsed: %d', [STRFVideo.biClrUsed]));
	Memo1.Lines.Add('            ' + Paragraph + format('biClrImportant: %d', [STRFVideo.biClrImportant]));

	i := Size - sizeof(STRFVideo);
	if (i > 0) then ShowData(i);

	result := true;
end;

function TForm1.STRFChunkAudio(Size: integer): boolean;
var	BytesRead: integer;
		ior, i	: integer;
begin
	result := false;

	BlockRead(AviFile, STRFAudio, sizeof(STRFAudio), BytesRead); ior := ioresult;
	if (ior <> 0) or (BytesRead <> sizeof(STRFAudio)) then
	begin
		Memo1.Lines.Add('            ' + Paragraph + 'Read error');
		exit;
	end;

	FileP := FilePos(AviFile); ior := ioresult;
	if (ior <> 0) then
	begin
		CloseFile(AviFile); ior := ioresult;
		Memo1.Lines.Add('          ' + Paragraph + 'FilePos error');
		exit;
	end;

	Memo1.Lines.Add('            ' + Paragraph + format('wFormatTag: %d %s', [STRFAudio.wFormatTag, WaveFormatTagStr(STRFAudio.wFormatTag)]));
	Memo1.Lines.Add('            ' + Paragraph + format('nChannels: %d', [STRFAudio.nChannels]));
	Memo1.Lines.Add('            ' + Paragraph + format('nSamplesPerSec: %d', [STRFAudio.nSamplesPerSec]));
	Memo1.Lines.Add('            ' + Paragraph + format('nAvgBytesPerSec: %d', [STRFAudio.nAvgBytesPerSec]));
	Memo1.Lines.Add('            ' + Paragraph + format('nBlockAlign: %d', [STRFAudio.nBlockAlign]));
	Memo1.Lines.Add('            ' + Paragraph + format('wBitsPerSample: %d', [STRFAudio.wBitsPerSample]));
	Memo1.Lines.Add('            ' + Paragraph + format('cbSize: %d', [STRFAudio.cbSize]));

	i := Size - sizeof(STRFAudio);
	if (i > 0) then ShowData(i);

	result := true;
end;

function TForm1.AVIHChunk(Size: integer): boolean;
var	AVIH		: TAVIH;
		BytesRead: integer;
		ior, i	: integer;
		s			: string;
begin
	result := false;

	BlockRead(AviFile, AVIH, sizeof(AVIH), BytesRead); ior := ioresult;
	if (ior <> 0) or (BytesRead <> sizeof(AVIH)) then
	begin
		Memo1.Lines.Add('            ' + Paragraph + 'Read error');
		exit;
	end;

	FileP := FilePos(AviFile); ior := ioresult;
	if (ior <> 0) then
	begin
		CloseFile(AviFile); ior := ioresult;
		Memo1.Lines.Add('          ' + Paragraph + 'FilePos error');
		exit;
	end;

	Memo1.Lines.Add('            ' + Paragraph + format('dwMicroSecPerFrame: %d .. %0.1ffps', [AVIH.dwMicroSecPerFrame, 1000000 / AVIH.dwMicroSecPerFrame]));
	Memo1.Lines.Add('            ' + Paragraph + format('dwMaxBytesPerSec: %d .. %0.1fKbit/s', [AVIH.dwMaxBytesPerSec, (AVIH.dwMaxBytesPerSec / 1000) * 8]));
	Memo1.Lines.Add('            ' + Paragraph + format('dwPaddingGranularity: %d', [AVIH.dwPaddingGranularity]));

	s := '';
	if ((AVIH.dwFlags and AVIF_HASINDEX) <> 0) then s := s + ', AVIF_HASINDEX';
	if ((AVIH.dwFlags and AVIF_MUSTUSEINDEX) <> 0) then s := s + ', AVIF_MUSTUSEINDEX';
	if ((AVIH.dwFlags and AVIF_ISINTERLEAVED) <> 0) then s := s + ', AVIF_ISINTERLEAVED';
	if ((AVIH.dwFlags and AVIF_WASCAPTUREFILE) <> 0) then s := s + ', AVIF_WASCAPTUREFILE';
	if ((AVIH.dwFlags and AVIF_COPYRIGHTED) <> 0) then s := s + ', AVIF_COPYRIGHTED';
	Memo1.Lines.Add('            ' + Paragraph + format('dwFlags: %d%s', [AVIH.dwFlags, s]));

	Memo1.Lines.Add('            ' + Paragraph + format('dwTotalFrames: %d', [AVIH.dwTotalFrames]));
	Memo1.Lines.Add('            ' + Paragraph + format('dwInitialFrames: %d', [AVIH.dwInitialFrames]));
	Memo1.Lines.Add('            ' + Paragraph + format('dwStreams: %d', [AVIH.dwStreams]));
	Memo1.Lines.Add('            ' + Paragraph + format('dwSuggestedBufferSize: %d', [AVIH.dwSuggestedBufferSize]));
	Memo1.Lines.Add('            ' + Paragraph + format('dwWidth: %d', [AVIH.dwWidth]));
	Memo1.Lines.Add('            ' + Paragraph + format('dwHeight: %d', [AVIH.dwHeight]));

	i := Size - sizeof(AVIH);
	if (i > 0) then ShowData(i);

	result := true;
end;

function TForm1.IDX1Chunk(Size: integer): boolean;
var	Index		: TIDX1;
		BytesRead: integer;
		ior		: integer;
		s			: string;
begin
	result := false;

	BlockRead(AviFile, Index, sizeof(Index), BytesRead); ior := ioresult;
	if (ior <> 0) or (BytesRead <> sizeof(Index)) then
	begin
		Memo1.Lines.Add('              ' + Paragraph + 'Read error');
		exit;
	end;

	Memo1.Lines.Add(IntToHex(FileP, 8) + ':   ' + Paragraph + format('ckid: %s', [fourcc_to_str(Index.ckid)]));

	FileP := FilePos(AviFile); ior := ioresult;
	if (ior <> 0) then
	begin
		CloseFile(AviFile); ior := ioresult;
		Memo1.Lines.Add('          ' + Paragraph + 'FilePos error');
		exit;
	end;

	s := '';
	if ((Index.dwFlags and AVIIF_LIST) <> 0) then s := s + ', AVIIF_LIST';
	if ((Index.dwFlags and AVIIF_KEYFRAME) <> 0) then s := s + ', AVIIF_KEYFRAME';
	if ((Index.dwFlags and AVIIF_FIRSTPART) <> 0) then s := s + ', AVIIF_FIRSTPART';
	if ((Index.dwFlags and AVIIF_LASTPART) <> 0) then s := s + ', AVIIF_LASTPART';
	if ((Index.dwFlags and AVIIF_NOTIME) <> 0) then s := s + ', AVIIF_NOTIME';
	if ((Index.dwFlags and AVIIF_COMPUSE) <> 0) then s := s + ', AVIIF_COMPUSE';
	Memo1.Lines.Add('              ' + Paragraph + format('dwFlags: %d%s', [Index.dwFlags, s]));

	Memo1.Lines.Add('              ' + Paragraph + 'dwChunkOffset: ' + IntToHex(Index.dwChunkOffset, 8));
	Memo1.Lines.Add('              ' + Paragraph + format('dwChunkLength: %d', [Index.dwChunkLength]));

	inc(FileP, BytesRead);
	
	result := true;
end;

function TForm1.IDX2Chunk(Size: integer): boolean;
var	Index		: TIDX2;
		BytesRead: integer;
		ior		: integer;
		s			: string;
begin
	result := false;

	BlockRead(AviFile, Index, sizeof(Index), BytesRead); ior := ioresult;
	if (ior <> 0) or (BytesRead <> sizeof(Index)) then
	begin
		Memo1.Lines.Add('            ' + Paragraph + 'Read error');
		exit;
	end;

	FileP := FilePos(AviFile); ior := ioresult;
	if (ior <> 0) then
	begin
		CloseFile(AviFile); ior := ioresult;
		Memo1.Lines.Add('          ' + Paragraph + 'FilePos error');
		exit;
	end;

	Memo1.Lines.Add('            ' + Paragraph + format('wLongsPerEntry: %d', [Index.wLongsPerEntry]));	// size of each entry in aIndex array
	Memo1.Lines.Add('            ' + Paragraph + format('bIndexSubType: %d', [Index.bIndexSubType]));		// future use. must be 0
	Memo1.Lines.Add('            ' + Paragraph + format('bIndexType: %d', [Index.bIndexType]));				// one of AVI_INDEX_* codes
	Memo1.Lines.Add('            ' + Paragraph + format('nEntriesInUse: %d', [Index.nEntriesInUse]));		// index of first unused member in aIndex array
	Memo1.Lines.Add('            ' + Paragraph + format('dwChunkId: %s', [fourcc_to_str(Index.dwChunkId)]));		// fcc of what is indexed

	if (Size > sizeof(Index)) then
		Memo1.Lines.Add('            ' + Paragraph + format('extra bytes: %d', [Size - sizeof(Index)]));

	result := true;
end;

function TForm1.GetChunkString(Size: integer): boolean;
var	ChunkStr	: pchar;
		BytesRead: integer;
		ior		: integer;
begin
	result := false;

	if (Size <= 0) then
	begin
		result := true;
		exit;
	end;

	ChunkStr := nil;
	GetMem(ChunkStr, Size + 1);
	if (ChunkStr = nil) then
	begin
		CloseFile(AviFile); ior := ioresult;
		Memo1.Lines.Add('          ' + Paragraph + 'could not get memory');
		exit;
	end;

	fillchar(ChunkStr^, Size + 1, 0);
	BlockRead(AviFile, ChunkStr^, Size, BytesRead); ior := ioresult;
	if (ior <> 0) or (BytesRead <> Size) then
	begin
		Memo1.Lines.Add('            ' + Paragraph + 'Read error');
		exit;
	end;

	FileP := FilePos(AviFile); ior := ioresult;
	if (ior <> 0) then
	begin
		CloseFile(AviFile); ior := ioresult;
		Memo1.Lines.Add('          ' + Paragraph + 'FilePos error');
		exit;
	end;

	Memo1.Lines.Add('            ' + Paragraph + ChunkStr);

	FreeMem(ChunkStr);
	ChunkStr := nil;

	result := true;
end;

function TForm1.GetChunkID: boolean;
var ior, BytesRead: integer;
begin
	result := false;

	BlockRead(AviFile, ChunkID, sizeof(ChunkID), BytesRead); ior := ioresult;
	if (ior <> 0) or (BytesRead <> sizeof(ChunkID)) then
	begin
		CloseFile(AviFile); ior := ioresult;
		Memo1.Lines.Add('          ' + Paragraph + 'Read error');
		exit;
	end;

	FileP := FilePos(AviFile); ior := ioresult;
	if (ior <> 0) then
	begin
		CloseFile(AviFile); ior := ioresult;
		Memo1.Lines.Add('          ' + Paragraph + 'FilePos error');
		exit;
	end;

	result := true;
end;

function TForm1.GetChunkSize: boolean;
var	ior, i			: integer;
		BytesRead		: integer;
begin
	result := false;

	BlockRead(AviFile, ChunkSize, sizeof(ChunkSize), BytesRead); ior := ioresult;
	if (ior <> 0) or (BytesRead <> sizeof(ChunkSize)) then
	begin
		CloseFile(AviFile); ior := ioresult;
		Memo1.Lines.Add('          ' + Paragraph + 'Read error');
		exit;
	end;

	ChunkPos := FilePos(AviFile); ior := ioresult;
	if (ior <> 0) then
	begin
		CloseFile(AviFile); ior := ioresult;
		Memo1.Lines.Add('          ' + Paragraph + 'FilePos error');
		exit;
	end;

	FileP := ChunkPos;
		
	result := true;
end;

function TForm1.SeekTo(i: integer): boolean;
var ior: integer;
begin
	result := false;

	Seek(AviFile, i); ior := ioresult;
	if (ior <> 0) then
	begin
		CloseFile(AviFile); ior := ioresult;
		Memo1.Lines.Add('          ' + Paragraph + 'Seek error');
		exit;
	end;

	FileP := FilePos(AviFile); ior := ioresult;
	if (ior <> 0) then
	begin
		CloseFile(AviFile); ior := ioresult;
		Memo1.Lines.Add('          ' + Paragraph + 'FilePos error');
		exit;
	end;

	result := true;
end;

procedure TForm1.ShowAVIInfo(Sender: TObject; Filename: string);
var	ior, i	: integer;
		BytesRead: integer;
		s			: string;
begin
	Paragraph := '';
	EndOfListPos := 0;

	Stop := false;

	Filename := trim(Filename);
	if (Filename = '') then exit;
	if (not FileExists(Filename)) then
	begin
		CloseFile(AviFile); ior := ioresult;
		Memo1.Lines.Add('          ' + Paragraph + 'File does not exist');
		exit;
	end;
	Edit1.Text := Filename;

	Memo1.Clear;

	{$I-}
	Filemode := fmOpenRead;
	AssignFile(AviFile, Filename);
	Reset(AviFile, 1); ior := ioresult;
	if (ior <> 0) then
	begin
		Memo1.Lines.Add('          ' + Paragraph + 'Could not open the file');
		exit;
	end;

	// *********

	while (not eof(AviFile)) and (not Stop) do
	begin
		FileP := FilePos(AviFile); ior := ioresult;	// get current file position
		if (ior <> 0) then
		begin
			CloseFile(AviFile); ior := ioresult;
			Memo1.Lines.Add(IntToHex(FileP, 8) + ': ' + Paragraph + 'FilePos error');
			exit;
		end;

		if (not GetChunkID) then exit;

		s := ChunkID;
		ChunkSize := 0;

		if (length(s) <> 4) then
		begin	// error ... should never arrive here !
			i := FilePos(AviFile) - (sizeof(FOURCC) - 1); ior := ioresult;
			if (ior <> 0) then
			begin
				CloseFile(AviFile); ior := ioresult;
				Memo1.Lines.Add(IntToHex(FileP, 8) + ': ' + Paragraph + 'FilePos error');
				exit;
			end;
			if (not SeekTo(i)) then exit;
		end
		else
		if (CompareText(s, 'riff') = 0) then
		begin
			Paragraph := Paragraph + '  ';
			if (not GetChunkSize) then exit;
			Memo1.Lines.Add(IntToHex(FileP - 8, 8) + ': ' + Paragraph + ChunkID + ' ' + inttostr(ChunkSize));
		end
		else
		if (CompareText(s, 'avi ') = 0) then
		begin
			Paragraph := Paragraph + '  ';
			Memo1.Lines.Add(IntToHex(FileP - 4, 8) + ': ' + Paragraph + ChunkID);
		end
		else
		if (CompareText(s, 'avix') = 0) then	// used for larger than normal 2gig files
		begin
			Paragraph := Paragraph + '  ';
			Memo1.Lines.Add(IntToHex(FileP - 4, 8) + ': ' + Paragraph + ChunkID);
		end
		else
		if (CompareText(s, 'hdrx') = 0) then	// used for larger than normal 2gig files
		begin
			if (not GetChunkSize) then exit;
			Memo1.Lines.Add(IntToHex(FileP - 8, 8) + ': ' + Paragraph + ChunkID + ' ' + inttostr(ChunkSize));
			ChunkSize := (ChunkSize + 1) and $fffffffe;			// next chunk is always on a 2 byte boundry
			if (not SeekTo(ChunkPos + ChunkSize)) then exit;
		end
		else
		if (CompareText(s, 'list') = 0) then
		begin
			if (not GetChunkSize) then exit;

			if (EndOfListPos = 0) then
			begin
				EndOfListPos := FileP + ChunkSize;
				Paragraph := '      ';
			end
			else
			if (EndOfListPos <= FileP) then
			begin
				EndOfListPos := FileP + ChunkSize;
				Paragraph := '      ';
			end
			else
				Paragraph := Paragraph + '  ';
			Memo1.Lines.Add(IntToHex(FileP - 8, 8) + ': ' + Paragraph + ChunkID + ' ' + inttostr(ChunkSize));
		end
		else
		if (CompareText(s, 'hdrl') = 0) then
		begin
			Paragraph := Paragraph + '  ';
			Memo1.Lines.Add(IntToHex(FileP - 4, 8) + ': ' + Paragraph + ChunkID);
		end
		else
		if (CompareText(s, 'avih') = 0) then
		begin
			if (not GetChunkSize) then exit;
			Memo1.Lines.Add(IntToHex(FileP - 8, 8) + ': ' + Paragraph + ChunkID + ' ' + inttostr(ChunkSize));

			if (not AVIHChunk(ChunkSize)) then exit;

			ChunkSize := (ChunkSize + 1) and $fffffffe;			// next chunk is always on a 2 byte boundry
			if (not SeekTo(ChunkPos + ChunkSize)) then exit;
		end
		else
		if (CompareText(s, 'strl') = 0) then
		begin
			Paragraph := Paragraph + '  ';
			Memo1.Lines.Add(IntToHex(FileP - 4, 8) + ': ' + Paragraph + ChunkID);
		end
		else
		if (CompareText(s, 'strh') = 0) then
		begin
			if (not GetChunkSize) then exit;
			Memo1.Lines.Add(IntToHex(FileP - 8, 8) + ': ' + Paragraph + ChunkID + ' ' + inttostr(ChunkSize));

			if (not STRHChunk(ChunkSize)) then exit;

			ChunkSize := (ChunkSize + 1) and $fffffffe;			// next chunk is always on a 2 byte boundry
			if (not SeekTo(ChunkPos + ChunkSize)) then exit;
		end
		else
		if (CompareText(s, 'strf') = 0) then
		begin
			if (not GetChunkSize) then exit;
			Memo1.Lines.Add(IntToHex(FileP - 8, 8) + ': ' + Paragraph + ChunkID + ' ' + inttostr(ChunkSize));

			s := fourcc_to_str(STRH.fccType);
			if (CompareText(s, 'vids') = 0) then
			begin
				if (not STRFChunkVideo(ChunkSize)) then exit;
			end
			else
			if (CompareText(s, 'auds') = 0) then
			begin
				if (not STRFChunkAudio(ChunkSize)) then exit;
			end;

			ChunkSize := (ChunkSize + 1) and $fffffffe;			// next chunk is always on a 2 byte boundry
			if (not SeekTo(ChunkPos + ChunkSize)) then exit;
		end
		else
		if (CompareText(s, 'strd') = 0) then
		begin
			Paragraph := Paragraph + '  ';
			Memo1.Lines.Add(IntToHex(FileP - 4, 8) + ': ' + Paragraph + ChunkID);
		end
		else
		if (CompareText(s, 'strn') = 0) then
		begin
			Paragraph := Paragraph + '  ';
			Memo1.Lines.Add(IntToHex(FileP - 4, 8) + ': ' + Paragraph + ChunkID);
		end
		else
		if (CompareText(s, 'movi') = 0) then
		begin
			Memo1.Lines.Add(IntToHex(FileP - 4, 8) + ': ' + Paragraph + ChunkID);
		end
		else
		if (CompareText(s[3] + s[4], 'dc') = 0) then	// compressed DIB
		begin
			if (not GetChunkSize) then exit;
			Memo1.Lines.Add(IntToHex(FileP - 8, 8) + ': ' + Paragraph + ChunkID + ' ' + inttostr(ChunkSize) + ' .. video chunk - compressed DIB');

			ChunkSize := (ChunkSize + 1) and $fffffffe;			// next chunk is always on a 2 byte boundry
			if (not SeekTo(ChunkPos + ChunkSize)) then exit;
		end
		else
		if (CompareText(s[3] + s[4], 'db') = 0) then	// uncompressed DIB
		begin
			if (not GetChunkSize) then exit;
			Memo1.Lines.Add(IntToHex(FileP - 8, 8) + ': ' + Paragraph + ChunkID + ' ' + inttostr(ChunkSize) + ' .. video chunk - uncompressed DIB');

			ChunkSize := (ChunkSize + 1) and $fffffffe;			// next chunk is always on a 2 byte boundry
			if (not SeekTo(ChunkPos + ChunkSize)) then exit;
		end
		else
		if (CompareText(s[3] + s[4], 'wb') = 0) then	// audio data
		begin
			if (not GetChunkSize) then exit;
			Memo1.Lines.Add(IntToHex(FileP - 8, 8) + ': ' + Paragraph + ChunkID + ' ' + inttostr(ChunkSize) + ' .. audio chunk');

			ChunkSize := (ChunkSize + 1) and $fffffffe;			// next chunk is always on a 2 byte boundry
			if (not SeekTo(ChunkPos + ChunkSize)) then exit;
		end
		else
		if (CompareText(s[3] + s[4], 'pc') = 0) then	// palette change
		begin
			if (not GetChunkSize) then exit;
			Memo1.Lines.Add(IntToHex(FileP - 8, 8) + ': ' + Paragraph + ChunkID + ' ' + inttostr(ChunkSize) + ' .. palette change');

			ChunkSize := (ChunkSize + 1) and $fffffffe;			// next chunk is always on a 2 byte boundry
			if (not SeekTo(ChunkPos + ChunkSize)) then exit;
		end
		else
		if (CompareText(s, 'rec ') = 0) then
		begin
			Paragraph := Paragraph + '  ';
			Memo1.Lines.Add(IntToHex(FileP - 4, 8) + ': ' + Paragraph + ChunkID);
		end
		else
		if (CompareText(s, 'IARL') = 0) then	// indicates where the subject of the file is archived.
		begin
			Paragraph := '      ';
			if (not GetChunkSize) then exit;
			Memo1.Lines.Add(IntToHex(FileP - 8, 8) + ': ' + Paragraph + ChunkID + ' ' + inttostr(ChunkSize));

			ChunkSize := (ChunkSize + 1) and $fffffffe;			// next chunk is always on a 2 byte boundry
			if (not SeekTo(ChunkPos + ChunkSize)) then exit;
		end
		else
		if (CompareText(s, 'IART') = 0) then	// artist of the original subject of the file
		begin
			Paragraph := '      ';
			if (not GetChunkSize) then exit;
			Memo1.Lines.Add(IntToHex(FileP - 8, 8) + ': ' + Paragraph + ChunkID + ' ' + inttostr(ChunkSize));

			if (not GetChunkString(ChunkSize)) then exit;

			ChunkSize := (ChunkSize + 1) and $fffffffe;			// next chunk is always on a 2 byte boundry
			if (not SeekTo(ChunkPos + ChunkSize)) then exit;
		end
		else
		if (CompareText(s, 'ICMS') = 0) then	// the name of the person or organization that commissioned the subject of the file
		begin
			Paragraph := '      ';
			if (not GetChunkSize) then exit;
			Memo1.Lines.Add(IntToHex(FileP - 8, 8) + ': ' + Paragraph + ChunkID + ' ' + inttostr(ChunkSize));

			if (not GetChunkString(ChunkSize)) then exit;

			ChunkSize := (ChunkSize + 1) and $fffffffe;			// next chunk is always on a 2 byte boundry
			if (not SeekTo(ChunkPos + ChunkSize)) then exit;
		end
		else
		if (CompareText(s, 'ICMT') = 0) then	// general comments about the file
		begin
			Paragraph := '      ';
			if (not GetChunkSize) then exit;
			Memo1.Lines.Add(IntToHex(FileP - 8, 8) + ': ' + Paragraph + ChunkID + ' ' + inttostr(ChunkSize));

			if (not GetChunkString(ChunkSize)) then exit;

			ChunkSize := (ChunkSize + 1) and $fffffffe;			// next chunk is always on a 2 byte boundry
			if (not SeekTo(ChunkPos + ChunkSize)) then exit;
		end
		else
		if (CompareText(s, 'ICOP') = 0) then	// copyright information
		begin
			Paragraph := '      ';
			if (not GetChunkSize) then exit;
			Memo1.Lines.Add(IntToHex(FileP - 8, 8) + ': ' + Paragraph + ChunkID + ' ' + inttostr(ChunkSize));

			if (not GetChunkString(ChunkSize)) then exit;

			ChunkSize := (ChunkSize + 1) and $fffffffe;			// next chunk is always on a 2 byte boundry
			if (not SeekTo(ChunkPos + ChunkSize)) then exit;
		end
		else
		if (CompareText(s, 'ICRD') = 0) then	// Creation date
		begin
			Paragraph := '      ';
			if (not GetChunkSize) then exit;
			Memo1.Lines.Add(IntToHex(FileP - 8, 8) + ': ' + Paragraph + ChunkID + ' ' + inttostr(ChunkSize));

			ChunkSize := (ChunkSize + 1) and $fffffffe;			// next chunk is always on a 2 byte boundry
			if (not SeekTo(ChunkPos + ChunkSize)) then exit;
		end
		else
		if (CompareText(s, 'ICRP') = 0) then	// crop method
		begin
			Paragraph := '      ';
			if (not GetChunkSize) then exit;
			Memo1.Lines.Add(IntToHex(FileP - 8, 8) + ': ' + Paragraph + ChunkID + ' ' + inttostr(ChunkSize));

			ChunkSize := (ChunkSize + 1) and $fffffffe;			// next chunk is always on a 2 byte boundry
			if (not SeekTo(ChunkPos + ChunkSize)) then exit;
		end
		else
		if (CompareText(s, 'IDIM') = 0) then	// specifies the size of the original subject of the file
		begin
			Paragraph := '      ';
			if (not GetChunkSize) then exit;
			Memo1.Lines.Add(IntToHex(FileP - 8, 8) + ': ' + Paragraph + ChunkID + ' ' + inttostr(ChunkSize));

			ChunkSize := (ChunkSize + 1) and $fffffffe;			// next chunk is always on a 2 byte boundry
			if (not SeekTo(ChunkPos + ChunkSize)) then exit;
		end
		else
		if (CompareText(s, 'IDPI') = 0) then	// dots per inch
		begin
			Paragraph := '      ';
			if (not GetChunkSize) then exit;
			Memo1.Lines.Add(IntToHex(FileP - 8, 8) + ': ' + Paragraph + ChunkID + ' ' + inttostr(ChunkSize));

			ChunkSize := (ChunkSize + 1) and $fffffffe;			// next chunk is always on a 2 byte boundry
			if (not SeekTo(ChunkPos + ChunkSize)) then exit;
		end
		else
		if (CompareText(s, 'IENG') = 0) then	// name of the engineer who worked on the file
		begin
			Paragraph := '      ';
			if (not GetChunkSize) then exit;
			Memo1.Lines.Add(IntToHex(FileP - 8, 8) + ': ' + Paragraph + ChunkID + ' ' + inttostr(ChunkSize));

			if (not GetChunkString(ChunkSize)) then exit;

			ChunkSize := (ChunkSize + 1) and $fffffffe;			// next chunk is always on a 2 byte boundry
			if (not SeekTo(ChunkPos + ChunkSize)) then exit;
		end
		else
		if (CompareText(s, 'IGNR') = 0) then	// Genre. original work description
		begin
			Paragraph := '      ';
			if (not GetChunkSize) then exit;
			Memo1.Lines.Add(IntToHex(FileP - 8, 8) + ': ' + Paragraph + ChunkID + ' ' + inttostr(ChunkSize));

			if (not GetChunkString(ChunkSize)) then exit;

			ChunkSize := (ChunkSize + 1) and $fffffffe;			// next chunk is always on a 2 byte boundry
			if (not SeekTo(ChunkPos + ChunkSize)) then exit;
		end
		else
		if (CompareText(s, 'ikey') = 0) then	// keyword list
		begin
			Paragraph := '      ';
			if (not GetChunkSize) then exit;
			Memo1.Lines.Add(IntToHex(FileP - 8, 8) + ': ' + Paragraph + ChunkID + ' ' + inttostr(ChunkSize));

			if (not GetChunkString(ChunkSize)) then exit;

			ChunkSize := (ChunkSize + 1) and $fffffffe;			// next chunk is always on a 2 byte boundry
			if (not SeekTo(ChunkPos + ChunkSize)) then exit;
		end
		else
		if (CompareText(s, 'ilgt') = 0) then	// lightness change settings
		begin
			Paragraph := '      ';
			if (not GetChunkSize) then exit;
			Memo1.Lines.Add(IntToHex(FileP - 8, 8) + ': ' + Paragraph + ChunkID + ' ' + inttostr(ChunkSize));

			ChunkSize := (ChunkSize + 1) and $fffffffe;			// next chunk is always on a 2 byte boundry
			if (not SeekTo(ChunkPos + ChunkSize)) then exit;
		end
		else
		if (CompareText(s, 'inam') = 0) then	// file subject
		begin
			Paragraph := '      ';
			if (not GetChunkSize) then exit;
			Memo1.Lines.Add(IntToHex(FileP - 8, 8) + ': ' + Paragraph + ChunkID + ' ' + inttostr(ChunkSize));

			if (not GetChunkString(ChunkSize)) then exit;

			ChunkSize := (ChunkSize + 1) and $fffffffe;			// next chunk is always on a 2 byte boundry
			if (not SeekTo(ChunkPos + ChunkSize)) then exit;
		end
		else
		if (CompareText(s, 'iprd') = 0) then	// id of intented program
		begin
			Paragraph := '      ';
			if (not GetChunkSize) then exit;
			Memo1.Lines.Add(IntToHex(FileP - 8, 8) + ': ' + Paragraph + ChunkID + ' ' + inttostr(ChunkSize));

			if (not GetChunkString(ChunkSize)) then exit;

			ChunkSize := (ChunkSize + 1) and $fffffffe;			// next chunk is always on a 2 byte boundry
			if (not SeekTo(ChunkPos + ChunkSize)) then exit;
		end
		else
		if (CompareText(s, 'isft') = 0) then	// id of program that created this file
		begin
			Paragraph := '      ';
			if (not GetChunkSize) then exit;
			Memo1.Lines.Add(IntToHex(FileP - 8, 8) + ': ' + Paragraph + ChunkID + ' ' + inttostr(ChunkSize));

			if (not GetChunkString(ChunkSize)) then exit;

			ChunkSize := (ChunkSize + 1) and $fffffffe;			// next chunk is always on a 2 byte boundry
			if (not SeekTo(ChunkPos + ChunkSize)) then exit;
		end
		else
		if (CompareText(s, 'isbj') = 0) then	// file description
		begin
			Paragraph := '      ';
			if (not GetChunkSize) then exit;
			Memo1.Lines.Add(IntToHex(FileP - 8, 8) + ': ' + Paragraph + ChunkID + ' ' + inttostr(ChunkSize));

			if (not GetChunkString(ChunkSize)) then exit;

			ChunkSize := (ChunkSize + 1) and $fffffffe;			// next chunk is always on a 2 byte boundry
			if (not SeekTo(ChunkPos + ChunkSize)) then exit;
		end
		else
		if (CompareText(s, 'idit') = 0) then
		begin
			Paragraph := '      ';
			if (not GetChunkSize) then exit;
			Memo1.Lines.Add(IntToHex(FileP - 8, 8) + ': ' + Paragraph + ChunkID + ' ' + inttostr(ChunkSize));

			if (not GetChunkString(ChunkSize)) then exit;

			ChunkSize := (ChunkSize + 1) and $fffffffe;			// next chunk is always on a 2 byte boundry
			if (not SeekTo(ChunkPos + ChunkSize)) then exit;
		end
		else
		if (CompareText(s, 'ismp') = 0) then
		begin
			Paragraph := '      ';
			if (not GetChunkSize) then exit;
			Memo1.Lines.Add(IntToHex(FileP - 8, 8) + ': ' + Paragraph + ChunkID + ' ' + inttostr(ChunkSize));

			if (not GetChunkString(ChunkSize)) then exit;

			ChunkSize := (ChunkSize + 1) and $fffffffe;			// next chunk is always on a 2 byte boundry
			if (not SeekTo(ChunkPos + ChunkSize)) then exit;
		end
		else
		if (CompareText(s, 'idx1') = 0) then	// AVI 1.0
		begin
			Paragraph := '      ';
			if (not GetChunkSize) then exit;
			Memo1.Lines.Add(IntToHex(FileP - 8, 8) + ': ' + Paragraph + ChunkID + ' ' + inttostr(ChunkSize) + ' .. video/audio chunk index table');

			if (ShowIndexTableCheckBox.Checked) then
				while (FileP < (ChunkPos + ChunkSize)) and (not eof(AviFile)) do
					if (not IDX1Chunk(ChunkSize)) then
						exit;

			if (eof(AviFile)) then break;								// all done

			ChunkSize := (ChunkSize + 1) and $fffffffe;			// next chunk is always on a 2 byte boundry
			if (not SeekTo(ChunkPos + ChunkSize)) then exit;
		end
		else
		if (CompareText(s, 'indx') = 0) then	// AVI 2.0 ... AVI Super index chunk
		begin
			if (not GetChunkSize) then exit;
			Memo1.Lines.Add(IntToHex(FileP - 8, 8) + ': ' + Paragraph + ChunkID + ' ' + inttostr(ChunkSize) + ' .. video/audio chunk index table');

			if (not IDX2Chunk(ChunkSize)) then exit;

			ChunkSize := (ChunkSize + 1) and $fffffffe;			// next chunk is always on a 2 byte boundry
			if (not SeekTo(ChunkPos + ChunkSize)) then exit;
		end
		else
		if (CompareText(s, 'JUNK') = 0) then
		begin
			Paragraph := '      ';
			if (not GetChunkSize) then exit;
			Memo1.Lines.Add(IntToHex(FileP - 8, 8) + ': ' + Paragraph + ChunkID + ' ' + inttostr(ChunkSize));

			if (ShowJunkCheckBox.Checked) then ShowData(ChunkSize);

			ChunkSize := (ChunkSize + 1) and $fffffffe;			// next chunk is always on a 2 byte boundry
			if (not SeekTo(ChunkPos + ChunkSize)) then exit;
		end
		else
		begin	// should never arrive here !
			i := FilePos(AviFile) - (sizeof(FOURCC) - 1); ior := ioresult;
			if (ior <> 0) then
			begin
				CloseFile(AviFile); ior := ioresult;
				Memo1.Lines.Add(IntToHex(FileP, 8) + ': ' + Paragraph + 'FilePos error');
				exit;
			end;
			if (not SeekTo(i)) then exit;
		end;

		LastChunkID := ChunkID;

		Application.ProcessMessages;
	end;

	// *********

	Memo1.Lines.Add('');

	CloseFile(AviFile); ior := ioresult;
	{$I+}
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
	if (OpenDialog1.Execute) then
		ShowAVIInfo(Self, OpenDialog1.FileName);
end;

procedure TForm1.FormCreate(Sender: TObject);
var v1, v2, v3, v4: word;
begin
	Edit1.Clear;
	Memo1.Clear;

	GetBuildInfo(v1, v2, v3, v4);
	Caption := format('%s .. v%d.%d.%d.%d', [Application.Title, v1, v2, v3, v4]);  
end;

procedure TForm1.StopButtonClick(Sender: TObject);
begin
	Stop := true;
end;

procedure TForm1.FormKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
	case Key of
		116	:	begin	// refresh the display when F5 is pressed
						if (length(trim(Edit1.Text)) > 0) then
							ShowAVIInfo(Self, Edit1.Text);
					end;
	end;
end;

end.

